'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = component;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _simmutable = require('simmutable');

var _simmutable2 = _interopRequireDefault(_simmutable);

var _objectPath = require('object-path');

var _objectPath2 = _interopRequireDefault(_objectPath);

var _actionCreator = require('./action-creator');

var _actionCreator2 = _interopRequireDefault(_actionCreator);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function component(component) {
  var reactComponent = _react2.default.createClass({
    displayName: component.displayName,

    componentDidMount: function componentDidMount() {
      this.boundForceUpdate = this.forceUpdate.bind(this);
      _simmutable2.default.on('change', this.boundForceUpdate);
    },
    componentWillUnmount: function componentWillUnmount() {
      console.log('remove', component.displayName);
      _simmutable2.default.removeListener('change', this.boundForceUpdate);
    },
    render: function render() {
      var state = _simmutable2.default.get();
      var allActions = _actionCreator2.default.getAll();

      var props = Object.keys(component.propPaths || {}).reduce(function (memo, key) {
        memo[key] = _objectPath2.default.get(state, component.propPaths[key]);
        return memo;
      }, {});

      var actionProps = null;
      if (Array.isArray(component.actions)) {
        actionProps = component.actions.reduce(function (memo, key) {
          memo[key] = allActions[key];
          return memo;
        }, {});
      }

      return component.render(_extends({}, props, actionProps));
    }
  });
  return reactComponent;
}