import React from 'react'
import store from 'simmutable'
import path from 'object-path'
import actions from './action-creator'

export default function component (component) {
  let reactComponent = React.createClass({
    displayName: component.displayName,

    componentDidMount () {
      this.boundForceUpdate = this.forceUpdate.bind(this)
      store.on('change', this.boundForceUpdate)
    },

    componentWillUnmount () {
      console.log('remove', component.displayName)
      store.removeListener('change', this.boundForceUpdate)
    },

    render () {
      let state = store.get()
      let allActions = actions.getAll()

      let props = Object.keys(component.propPaths || {}).reduce((memo, key) => {
        memo[key] = path.get(state, component.propPaths[key])
        return memo
      }, {})

      let actionProps = null
      if (Array.isArray(component.actions)) {
        actionProps = component.actions.reduce((memo, key) => {
          memo[key] = allActions[key]
          return memo
        }, {})
      }

      return component.render({...props, ...actionProps})
    }
  })
  return reactComponent
}
